<template>
  <div class="locations-panel vertical-menu-panel flex-grow-0 flex-column" v-bind:class="panelDisplayClass()">

    <!-- locations-panel-header -->
    <div class="locations-panel-header d-flex flex-row bg-primary pl-3 py-3">
      <h1 class="flex-grow-1 text-light mb-0">
        <span class="mr-2"><font-awesome-icon icon="map-marker"/></span>
        Locais
      </h1>
      <button class="btn flex-grow-0 text-light mr-2 close-btn" @click="closePanel">
        <font-awesome-icon icon="times"/>
      </button>
    </div>

    <!-- listings -->
    <div class="d-flex flex-grow-1 flex-row">
      <location-groups-panel/>
      <filtered-location-panel/>
    </div>

  </div>
</template>

<script>
import { SET_WORKSPACE_CURRENT_PANEL } from '@/workspace/store/mutations'
import WorkspaceGetter from '@/workspace/mixins/WorkspaceGetter'
import LocationGroupsPanel from '@/workspace/components/locations/LocationGroupsPanel'
import FilteredLocationPanel from '@/workspace/components/locations/FilteredLocationPanel'

export default {
  name: 'locationspanel',

  mixins: [
    WorkspaceGetter
  ],

  props: {
    name: {
      type: String,
      required: true
    }
  },

  computed: {
    isCurrentPanel: {
      get() {
        return this.$store.getters.workspaceCurrentPanel(this.workspaceId) === this.name
      }
    },
  },

  methods: {
    panelDisplayClass() {
      return {
        'd-flex': this.isCurrentPanel,
        'd-none': !this.isCurrentPanel,
      }
    },

    closePanel() {
      this.$store.commit(SET_WORKSPACE_CURRENT_PANEL, {
        workspaceId: this.workspaceId,
        pane: null
      })
    },
  },

  components: {
    LocationGroupsPanel,
    FilteredLocationPanel,
  },
}
</script>
